 TITLE VCRTEXT
 INCLUDE SE.ASM
 DATA SEGMENT WORD PUBLIC
      EXTRN WindMax:Word
      EXTRN WindMin:Word
      EXTRN Frame:Byte
      EXTRN InverseAttr:Byte
      EXTRN ScreenMode:Byte
      EXTRN TextAttr:Byte
      EXTRN DirectVideo:Byte
      CursorPos DW ?
      X1        DB ?
      Y1        DB ?
      X2        DB ?
      Y2        DB ?
 DATA ENDS
 CODE SEGMENT BYTE PUBLIC
      ASSUME CS:CODE,DS:DATA

      PUBLIC FrameWindow ,MoveFromScreen,MoveToScreen
      PUBLIC Inverse
      PUBLIC ReadScreen,ReadAttr
      EXTRN ReInitCRT:Far


 Write      Proc Near
            PUSH AX
            MOV BH,0
            MOV AH,2
            CALL VIDEO
            POP AX
            Cmp  ScreenMode,4
            JB   @@1
            CMP  ScreenMode,6
            JE   @@1
            CMP  ScreenMode,7
            JE   @@1
            PUSH AX
            MOV  AX, 9DBH
            MOV BL, TextAttr
            PUSH CX
            MOV CL,4
            SHR BL,CL
            POP CX
            CALL Video
            POP AX
            MOV AH,TextAttr
            AND AH, 0FH
            XOR BL, AH
            OR BL, 80H
            MOV AH,9
            CALL Video
            RET
 @@1:       Mov BL,TextAttr
            MOV AH,9
            CALL Video
            RET
 Write    ENDP
 FrameWindow Proc far
          PUSH    BP
          MOV     BP,SP
          MOV     AH,3
          MOV     BH,0
          INT     10H
          MOV     CursorPos,DX
          MOV     DH,[BP+10]
          MOV     DL,[BP+12]
          DEC     DL
          DEC     DH
          MOV     X1,DL
          MOV     Y1,DL
          MOV     AL,Frame[0]
          MOV     CX,1
          CALL    Write
          INC     DL
          MOV     CL,[BP+8]
          DEC     CL
          MOV     X2,CL
          XOR     CH,CH
          SUB     CL,DL
          MOV     AL,Frame[5]
          Call    Write
          MOV     DH,[BP+6]
          DEC     DH
          MOV     Y2,DH
          CALL    WRITE
          DEC     DL
          MOV     CX,1
          MOV     AL,Frame[2]
          CALL    Write
          MOV     DL,X2
          MOV     AL,Frame[3]
          CALL    Write
          MOV     DH,Y1
          MOV     AL,Frame[1]
          CALL    Write
          INC     DH
          MOV     CL,Y2
          SUB     CL,Y1
          XOR     CH,CH
          MOV     AL,Frame[4]
          DEC     CX
@@1:      PUSH    CX
          MOV     CX,1
          MOV     DL,X1
          CALL    Write
          MOV     DL,X2
          CALL    Write
          POP     CX
          Inc     DH
          LOOP    @@1
          MOV     AH,2
          MOV     BH,0
          MOV     DX,CursorPos
          Call    Video
          POP     BP
          RET 8
FrameWindow ENDP
Inverse Proc Far
          CALL ReInitCRT
          MOV BX,SP
          MOV CX,SS:[BX+4]
          CMP ScreenMode,4
          JB @@2
          CMP ScreenMode,7
          JE @@2
          CMP ScreenMode,6
          JE @@7
          MOV BL,InverseAttr
          MOV BH,0
          TEST BL,0FH
          JNZ @@1
          MOV  BL,0FH
@@1:      MOV AX,9DBH
          Call Video
          RET 2
@@2:      MOV AH,3
          XOR BH,Bh
          INT 10H
          MOV AL,DH
          XOR DH,DH
          CMP ScreenMode,2
          JB @@3
          MOV BL, 160
          JMP SHORT @@4
@@3:      MOV BL,80
@@4:      MUL BL
          SHL DX,1
          ADD AX,DX
          INC AX
          MOV DI,AX
          MOV AX,0B000H
          CMP ScreenMode,7
          JNE @@5
          ADD AX,0800H
@@5:      MOV ES,AX
          CLD
          MOV AL, InverseAttr
@@6:      STOSB
          Inc DI
          LOOP @@6
          RET 2
@@7:      MOV CursorPos,CX
          MOV AH,3
          XOR BH,Bh
          INT 10H
          MOV AL,DH
          MOV BL,160
          MUL BL
          SHL AX,1
          XOR DH,DH
          ADD AX,DX
          MOV CX,4
          MOV SI,AX
          MOV AX,0B800H
          MOV ES,AX
@@8:      PUSH CX
          MOV DI,SI
          MOV CursorPos,CX
@@9:      NOT Byte Ptr ES:[DI]
          NOT BYTE PTR ES:[DI+8192]
          INC DI
          LOOP @@9
          POP CX
          ADD SI,80
          LOOP @@8
          RET 2
Inverse  ENDP
ReadScr   Proc Near
           MOV AH,3
           MOV BH,0
           INT 10H
           MOV CursorPos,DX
           MOV BX,SP
           MOV DH,SS:[BX+6]
           MOV DL,SS:[BX+8]
           DEC DH
           DEC DL
           ADD DX,WindMin
           MOV BH,0
           MOV AH,2
           CALL Video
           MOV AH,8
           INT 10H
           PUSH AX
           MOV DX,CursorPos
           MOV AH,2
           Call Video
           POP AX
           RET
ReadScr   ENDP
ReadScreen Proc Far
           CALL READSCR
           RET 4
ReadScreen EndP
ReadAttr  Proc Far
          Call ReadScr
          MOV AL,AH
          RET 4
ReadAttr ENDP
Video:

	PUSH	SI
	PUSH	DI
	PUSH	BP
	PUSH	ES
	INT	10H
	POP	ES
	POP	BP
	POP	DI
	POP	SI
	RET
MoveFromScreen Proc
        Dest Equ Dword Ptr [BP+4]
        Count EQu Byte Ptr [BP+8]
        Col Equ Byte Ptr [Bp+10]
        Row Equ Byte Ptr [Bp+12]
        Push BP
        Mov BP,SP
        Push DS
        Mov al,80
        Mov BX,0B800H
        Cmp ScreenMode,2
        JB @@40
        CMp ScreenMode,7
        JNE @@80
        Mov BX,0B000H
@@80:   Mov Al,80
        JMP Short @@1
@@40:   Mov al,40
@@1:    Mov Ds,Bx
        Mov Bl,Row
        Dec Bl
        Mul Bl
        Mov Bl,Col
        dec Bl
        xCHG AX,BX
        CBW
        Add ax,Bx
        SHL AX,1
        Mov Si,Ax
        Mov al,Count
        CBW
        Mov cx,ax
        LEs DI,Dest
        CLD
        Rep Movsw
@@x:     Pop ds
        Pop bp
        Retn 10
MoveFromScreen Endp
MoveToScreen Proc
        Push BP
        Mov BP,SP
        cmp DirectVideo,0
        JZ @@Bios
        Mov al,80
        Mov BX,0B800H
        Cmp ScreenMode,2
        JB @@40
        CMp ScreenMode,7
        JNE @@80
        Mov BX,0B000H
@@80:   Mov Al,80
        JMP Short @@1
@@40:   Mov al,40
@@1:    Mov Es,Bx
        Mov Bl,Row
        Dec Bl
        Mul Bl
        Mov Bl,Col
        dec Bl
        xCHG AX,BX
        CBW
        Add ax,Bx
        Shl Ax,1
        Mov Di,Ax
        Mov al,Count
        CBW
        Mov cx,ax
        Push DS
        LDs SI,Dest
        CLD
        Rep Movsw
        Pop ds
@@X:    Pop bp
        Retn 10
@@Bios:
        MOV     AH,3
        MOV     BH,0
        INT     10H
        MOV     CursorPos,DX
        Mov Dh,Row
        Dec DH
        Mov Dl,Col
        Dec dl
        Mov Al,Count
        CBW
        Mov CX,Ax
        Mov al,TextAttr
        Push AX
        Push ds
        lds si,dEST
        Mov Di,DS
        cLD
@@2:    lODSw
        Pop DS
        Push Cx
        Mov TextAttr,Ah
        Mov Cx,1
        Call Write
        Inc dl
        Pop Cx
        Push DS
        Mov DS,Di
        Loop @@2;
        Pop DS
        Pop Ax
        Mov TextAttr,Al
        MOV     AH,2
        MOV     BH,0
        MOV     DX,CursorPos
        Call    Video
        Jmp @@X
MoveToScreen EndP


Code ends
end
